#include <sourcemod>
#include <multicolors>
#include <cstrike>
#include <autoexecconfig>

#pragma semicolon 1

#pragma newdecls required

ConVar g_ConVar_FreePass_Admins;

ConVar g_ConVar_Block_Terrorist;
ConVar g_ConVar_Block_Counter_Terrorist;
ConVar g_ConVar_Block_Spectator;

ConVar g_ConVar_Block_Terrorist_Message;
ConVar g_ConVar_Block_Counter_Terrorist_Message;
ConVar g_ConVar_Block_Spectator_Message;

public Plugin myinfo = 
{
	name = "Block Join Teams", 
	author = "Lantejoula", 
	description = "Makes the All Teams Unjoinable", 
	version = "1.0", 
	url = "https://steamcommunity.com/id/lantejoula/"
};

public void OnPluginStart()
{
	LoadTranslations("blockjointeams.phrases");
	
	AutoExecConfig_SetFile("plugin.blockjointeams");
	
	g_ConVar_FreePass_Admins = CreateConVar("sm_freepass_admins", "0", "Allow admins to pass the spectator block? 1 = true, 0 = false.", 0, true, 0.0, true, 1.0);
	
	g_ConVar_Block_Terrorist = CreateConVar("sm_block_terrorist", "1", "Allow admins to pass the spectator block? 1 = true, 0 = false.", 0, true, 0.0, true, 1.0);
	g_ConVar_Block_Counter_Terrorist = CreateConVar("sm_block_counter_terrorist", "1", "Allow admins to pass the spectator block? 1 = true, 0 = false.", 0, true, 0.0, true, 1.0);
	g_ConVar_Block_Spectator = CreateConVar("sm_block_spectator", "1", "Allow admins to pass the spectator block? 1 = true, 0 = false.", 0, true, 0.0, true, 1.0);
	
	g_ConVar_Block_Terrorist_Message = CreateConVar("sm_block_terrorist_message", "1", "Allow admins to pass the spectator block? 1 = true, 0 = false.", 0, true, 0.0, true, 1.0);
	g_ConVar_Block_Counter_Terrorist_Message = CreateConVar("sm_block_counter_terrorist_message", "1", "Allow admins to pass the spectator block? 1 = true, 0 = false.", 0, true, 0.0, true, 1.0);
	g_ConVar_Block_Spectator_Message = CreateConVar("sm_block_spectator_message", "1", "Allow admins to pass the spectator block? 1 = true, 0 = false.", 0, true, 0.0, true, 1.0);
	
	AutoExecConfig_ExecuteFile();
	AutoExecConfig_CleanFile();
	
	AddCommandListener(Command_JoinTeam, "jointeam");
	AddCommandListener(Command_JoinTeam1, "jointeam");
	AddCommandListener(Command_JoinTeam2, "jointeam");
}


public Action Command_JoinTeam(int client, char[] command, int args)
{
	if (g_ConVar_Block_Spectator.BoolValue)
	{
		char Team[8];
		GetCmdArg(1, Team, sizeof(Team));
		int iTeam = StringToInt(Team);
		if (iTeam == 1) // Spectator
		{
			if (CheckCommandAccess(client, "sm_fake_command", ADMFLAG_GENERIC, true) && g_ConVar_FreePass_Admins.BoolValue)
			{
				return Plugin_Continue;
			}
			else
			{
				if (g_ConVar_Block_Spectator_Message.BoolValue)
					CPrintToChat(client, "%t %t", "Prefix", "Spectator");
				return Plugin_Handled;
			}
		}
		else
		{
			return Plugin_Continue;
		}
	}
	return Plugin_Continue;
}

public Action Command_JoinTeam1(int client, char[] command, int args)
{
	if (g_ConVar_Block_Terrorist.BoolValue)
	{
		char Team[8];
		GetCmdArg(1, Team, sizeof(Team));
		int iTeam = StringToInt(Team);
		if (iTeam == 2) // Terrorist
		{
			if (CheckCommandAccess(client, "sm_fake_command", ADMFLAG_GENERIC, true) && g_ConVar_FreePass_Admins.BoolValue)
			{
				return Plugin_Continue;
			}
			else
			{
				if (g_ConVar_Block_Terrorist_Message.BoolValue)
					CPrintToChat(client, "%t %t", "Prefix", "Terrorist");
				return Plugin_Handled;
			}
		}
		else
		{
			return Plugin_Continue;
		}
	}
	return Plugin_Continue;
}

public Action Command_JoinTeam2(int client, char[] command, int args)
{
	if (g_ConVar_Block_Counter_Terrorist.BoolValue)
	{
		char Team[8];
		GetCmdArg(1, Team, sizeof(Team));
		int iTeam = StringToInt(Team);
		if (iTeam == 3) // Counter Terrorist
		{
			if (CheckCommandAccess(client, "sm_fake_command", ADMFLAG_GENERIC, true) && g_ConVar_FreePass_Admins.BoolValue)
			{
				return Plugin_Continue;
			}
			else
			{
				if (g_ConVar_Block_Counter_Terrorist_Message.BoolValue)
					CPrintToChat(client, "%t %t", "Prefix", "CounterTerrorist");
				return Plugin_Handled;
			}
		}
		else
		{
			return Plugin_Continue;
		}
	}
	return Plugin_Continue;
} 